/*
 File: rc_phrase.cpp
 Date and Time: Fri Jan 30 18:55:21 2015 
*/
#include "rc_phrase.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_rc_phrase;// grammar's ns
// first set terminals
fsm_rules_reuse_table_type::fsm_rules_reuse_table_type(){
 no_rules_entries_ = 2;
 per_rule_s_table_[0] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[1] =  new Per_rule_s_reuse_table();
}
  Crc_phrase::
  Crc_phrase()
    :yacco2::CAbs_fsm
      ("rc_phrase.lex"
      ,"1.0"
      ,"24 May 2004"
      ,false
      ,"Dispatcher to parse raw character vocabulary."
      ,"Fri Jan 30 18:55:21 2015 "
      ,S1_Crc_phrase){
    
   cweb_marker__ = 0;
  
  }
 
Crc_phrase::~Crc_phrase(){

  for(int x = 0;x < 2;++x){
   ///delete fsm_rules_reuse_table.per_rule_s_table_[x];
  }
} 

  bool Crc_phrase::failed(){
      return false;
  }
  void Crc_phrase::op(){
   if(CWEB_MARKER != 0){
     cweb_marker__ = CWEB_MARKER;
     CWEB_MARKER=0;
   }
  
}
int Crc_phrase::rhs_to_rules_mapping_[5] = {
 -1
 ,0 // subrule 1 for rule 1
 ,1 // subrule 2 for rule 2
 ,1 // subrule 3 for rule 2
 ,1 // subrule 4 for rule 2
}; 
Rrc_phrase::Rrc_phrase(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rrc_phrase",0,Crc_phrase::R_Rrc_phrase_,P,false,false){
}

Rphrase::Rphrase(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rphrase",0,Crc_phrase::R_Rphrase_,P,false,false){
}

void Rphrase::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_rc_phrase* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
    ADD_TOKEN_TO_PRODUCER_QUEUE(*sf->p2__);
  
}

void Rphrase::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
    ADD_TOKEN_TO_ERROR_QUEUE(*sf->p2__);
  
}

void Rphrase::sr3(){
  
    CAbs_lr1_sym* sym = new Err_no_open_parenthesis;
    sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
    ADD_TOKEN_TO_ERROR_QUEUE(*sym);
  
}

